C     ******************************************************************
C        SPECIFICATIONS:
      PARAMETER (NODDIM=1000000, MaxHYD1=999)
      COMMON /BUFCOM/BUFF
      COMMON /ZONCOM/IZONE
      COMMON /CHCOM/ICH
      COMMON /IBFCOM/IBUFF
      DIMENSION BUFF(NODDIM), Buff3D(NODDIM)
      DIMENSION IBUFF(NODDIM), iHydGET(MaxHYD1)
      DOUBLE PRECISION VBVL,VBZNFL
      CHARACTER*80 TITLE
      CHARACTER*80 NAME, TxT
      CHARACTER*16 TEXT,CTMP, Header(MaxHYD1) 
      CHARACTER*20 sFORM
      CHARACTER*1 METHOD,IANS, tab
      CHARACTER*40 VERSON
      DIMENSION VAL(10)
      INCLUDE 'openspec.inc'
C     ------------------------------------------------------------------
      VERSON='BIN 2 ASCII ripper'
C
C-----DEFINE INPUT AND OUTPUT UNITS AND INITIALIZE OTHER VARIABLES
      INBUD=12
      IOUT=13
      tab = char(9)
C
C-----OPEN A LISTING FILE
      WRITE(*,*)
3     WRITE(*,*) ' Enter the name of an ASCII FILE for results:'
      READ(*,'(A)') NAME
      i = len_trim(NAME)
      if( i.le.1)then 
        NAME = 't.txt'
      endif  
      OPEN(UNIT=IOUT,FILE=NAME,ERR=3)
C
C-----OPEN THE CELL-BY-CELL BUDGET FILE
      WRITE(*,*)
10    WRITE(*,*) ' Enter the name of the file with BINARY info'
      READ(*,'(A)') NAME
      i = len_trim(NAME)
      if( i.le.1)then 
        NAME = 'out\Budget.bud'
      endif  
      OPEN(UNIT=INBUD,FILE=NAME,STATUS='OLD',FORM=FORM,ACCESS=ACCESS,
     1               ERR=10)
C
C-----READ GRID SIZE FROM BUDGET FILE AND REWIND
      Kheader = 0
      READ(INBUD,END=2000) KSTP,KPER,TEXT,NCOL,NROW,NLAY
      NZ = Nlay
      if(   ncol.lt.0 .or. ncol.gt.9999 .or. 
     +      nrow.lt.0 .or. nrow.gt.9999 .or.
     +      nlay.lt.-999 .or. nlay.gt.999 ) then
        REWIND(UNIT=INBUD)
        READ(INBUD,END=2000) KSTP,KPER,PERTIM,TOTIM,TEXT,NCOL,NROW,NLAY
        Kheader = 1
      endif  
      IF(NLAY.LT.0) NLAY=-NLAY
      REWIND(UNIT=INBUD)
      WRITE(*,*)
      WRITE(*,14) NLAY,NROW,NCOL
14    FORMAT(1X,I3,' layers',I10,' rows',I10,' columns')
C
C-----CHECK TO SEE IF NODIM IS LARGE ENOUGH
      NRC=NROW*NCOL
      NODES=NRC*NLAY
      IF(NODES.GT.NODDIM) THEN
         WRITE(*,*) ' PROGRAM ARRAYS ARE DIMENSIONED TOO SMALL'
         WRITE(*,*) ' PARAMETER NODDIM IS CURRENTLY',NODDIM
         WRITE(*,*) ' CHANGE NODDIM TO BE',NODES,' OR GREATER'
         STOP
      END IF
c  Scanning for True NZ if Kheader = 1
      if( kheader.eq.1 ) then
        TOTIMfirst = 0.
        j = 0
        do while( j.lt.999) 
          j = j + 1
          READ(INBUD)KSTP,KPER,PERTIM,TOTIM,TEXT,NCOL,NROW,NLAY
          if( TOTIMfirst .lt. 1e-9 ) then TOTIMfirst = TOTIM
          if( j.gt.1 .and. TOTIM.gt.TOTIMfirst ) then
            NZ = j-1
            j = 1000
            REWIND(UNIT=INBUD)
          else
            READ(INBUD) (BUFF(I),I=1,NODES)
          endif
        enddo
      endif
c          
      WRITE(*,*)
C
C ---- Ask for optional time series extraction file 
      WRITE(*,*)
      WRITE(*,*) ' Enter optional file of Row, column HYD locations'
      READ(*,'(A)') NAME
      if( len_trim(name).gt.1 ) then
        io = 69
        OPEN(UNIT=io,FILE=NAME,STATUS='OLD',ERR=15)
        WRITE(*,*)
        WRITE(*,*) ' Enter PREFIX for files of time series '
        READ(*,'(A)') NAME
        nNODES = 0
        do i = 1, MaxHYD1
          read(io,*,end=20) iR, iC
          nNODES = nNODES + 1
          iHydGET(nNODES) = (iR-1)*NCOL + iC
          kn = index(NAME,' ')-1
          TxT = NAME(1:kn)//'_R000-C000.txt'
          ki = index(txt,'R0')+1
          write(txt(ki:ki+2),'(i3.3)') iR
          ki = index(txt,'C0')+1
          write(txt(ki:ki+2),'(i3.3)') iC
          open(io+nNODES,file=TxT)
          Header(1) = 'KPER'
          if( kheader.eq.0 ) then 
            Header(2) = 'KSTP'
          else  
            Header(2) = 'TOTIM'
          endif
          ki = index(txt,'.')-1
          do j = 3, NZ+2
            Header(j) = 'L000-'//TxT(kn+2:ki)
            write(Header(j)(2:4),'(i3.3)') j-2
          enddo
          write(io+nNODES,'(999(a16,a1))') (Header(j),tab, j=1,NZ+2)
        enddo
      else
        io = 0
      endif  
      goto 20
 15   io = 0
 20   continue
      kOUNT = 0
      ICALC=0
C-----READ BUDGET DATA AND ACCUMULATE AS LONG AS TIME REMAINS CONSTANT.
C-----WHEN TIME CHANGES, PRINT THE BUDGET, REINITIALIZE, AND START OVER
      do while( iout.gt.0)
        kOUNT = kOUNT + 1
        if( kheader.eq.0 ) then 
          READ(INBUD,END=1000) KSTP,KPER,TEXT,NC,NR,NL
        else  
          READ(INBUD,END=1000) KSTP,KPER,PERTIM,TOTIM,TEXT,NC,NR,NL
        endif
      ITYPE=0
      IF(NL.LT.0) THEN
         READ(INBUD) ITYPE,DELT,PERTIM,TOTIM
         write(iout,'(i5,3G15.7)') ITYPE,DELT,PERTIM,TOTIM
         NVAL=1
         IF(ITYPE.EQ.5) THEN
            READ(INBUD) NVAL
            IF(NVAL.GT.1) THEN
               DO 101 N=2,NVAL
               READ(INBUD) CTMP
101            CONTINUE
            END IF
         END IF
         IF(ITYPE.EQ. 2 .OR. ITYPE.EQ.5) READ(INBUD) NLIST
      END IF
C
C-----READ THE BUDGET TERM DATA UNDER THE FOLLOWING CONDITIONS:
      IF(ITYPE.EQ.0 .OR. ITYPE.EQ.1) THEN
        IF(nodes.EQ.Nrow*ncol*Nlay) THEN
          sFORM = '(500G16.8)'
          write(sFORM(2:4),'(I3.3)') ncol
          do k = 1, Nlay
            write(iout,'(2i5,a16,3i10)') KSTP,KPER,TEXT,NCOL,NROW,k
            READ(INBUD) (BUFF(I),I=1,ncol*nrow)
            write(iout,sFORM)(BUFF(I),I=1,ncol*nrow)
          enddo    
        else
C  FULL 3-D ARRAY
         koff = mod(kOUNT-1,NZ)*Nrow*ncol
         READ(INBUD) (BUFF(I+koff),I=1,NODES)
c  Write CBC to ASCII
       if( koff.eq.(NZ-1)*Nrow*ncol ) then
         do i = ncol,nodes+koff,ncol
           if( mod(i-ncol,nrc).eq.0 ) then
             k = int((i-ncol)/nrc) + 1
             if( kheader.eq.0 ) then 
               write(iout,'(2i5,a16,3i10)') KSTP,KPER,TEXT,NCOL,NROW,k
             else  
               write(iout,'(2i5,2F12.2,a16,3i10)') KSTP,KPER,
     +                      PERTIM,TOTIM,TEXT,NCOL,NROW,k
             endif
           endif
           write(iout,'(500G16.8)')(buff(j),j=i-ncol+1,i)
         enddo
c  Burp optional time series          
         if( io.gt.0 ) then 
           do i = 1, nNODES
             j = iHydGET(i)
             if( kheader.eq.0 ) then 
               totim = KSTP 
             endif
             write(io+i,'(i5,a1,999(g15.7,a1))') kper,tab, TOTIM,tab,
     +                 (buff(k),tab,k=j,nodes+koff,nrow*ncol)
           enddo
         endif
        endif
       endif
      ELSE IF(ITYPE.EQ.3) THEN
C  1-LAYER ARRAY WITH LAYER INDICATOR ARRAY
         DO 260 I=1,NODES
         BUFF(I)=ZERO
260      CONTINUE
         READ(INBUD) (IBUFF(I),I=1,NRC)
         READ(INBUD) (BUFF(I),I=1,NRC)
         DO 270 I=1,NRC
         IF(IBUFF(I).NE.1) THEN
            LAYMOV=(IBUFF(I)-1)*NRC
            BUFF(LAYMOV+I)=BUFF(I)
            BUFF(I)=ZERO
         END IF
270      CONTINUE
      ELSE IF(ITYPE.EQ.4) THEN
C  1-LAYER ARRAY THAT DEFINES LAYER 1
         READ(INBUD) (BUFF(I),I=1,NRC)
         IF(NODES.GT.NRC) THEN
            DO 280 I=NRC+1,NODES
            BUFF(I)=ZERO
280         CONTINUE
         END IF
      ELSE IF(ICALC.EQ.0 .AND. NLIST.GT.0) THEN
C  LIST -- READ ONLY IF THE VALUES NEED TO BE SKIPPED
         DO 300 N=1,NLIST
         READ(INBUD) LOC,(VAL(I),I=1,NVAL)
300      CONTINUE
      END IF
       
      enddo   !! BOTTOM of DoWhile loop
c-------------------------------------------------- 
C  PRINT BUDGET BECAUSE END OF FILE WAS REACHED 
c
      if( io.gt.0 ) then 
        do i = 0, nNODES
          close(io+nNODES)
        enddo
      endif
c
1000  continue 
      STOP
C
C-----EMPTY BUDGET FILE
2000  WRITE(*,*) 'CELL-BY-CELL FLOW TERM FILE WAS EMPTY'
      STOP
C
      END
