C     ******************************************************************
C        SPECIFICATIONS:
      PARAMETER (NODDIM=1000000, MaxHYD1=999)
      COMMON /BUFCOM/BUFF
      COMMON /ZONCOM/IZONE
      COMMON /CHCOM/ICH
      COMMON /IBFCOM/IBUFF
      DIMENSION BUFF(NODDIM), Buff3D(NODDIM), Qacc(noddim)
      DIMENSION IBUFF(NODDIM), iHydGET(MaxHYD1)
      dimension DepthDY(MaxHYD1) 
      dimension QsimDY(MaxHYD1) 
      dimension DepthMEAS(MaxHYD1) 
      dimension rN(MaxHYD1) 
      DOUBLE PRECISION VBVL,VBZNFL
      CHARACTER*80 TITLE
      CHARACTER*80 NAME, TxT
      CHARACTER*16 TEXT,CTMP, Header(MaxHYD1) 
      CHARACTER*1 METHOD,IANS, tab
      CHARACTER*40 VERSON
      DIMENSION VAL(10)
      INCLUDE 'openspec.inc'
      io = 7
C     ------------------------------------------------------------------
      VERSON='MF2K budget 2 radial flow log'
C
C-----DEFINE INPUT AND OUTPUT UNITS AND INITIALIZE OTHER VARIABLES
      INBUD=12
      IOUT=13
      tab = char(9)
C
C-----OPEN A LISTING FILE
      WRITE(*,*)
3     WRITE(*,*) ' Enter the name of an ASCII FILE for results:'
      READ(*,'(A)') NAME
      if( NAME(1:1).eq.' ' ) NAME='t.txt'
      OPEN(UNIT=IOUT,FILE=NAME,ERR=3)
C
      WRITE(*,*)
      WRITE(*,*) ' Specify column for accumulating cumulative flow log'
      READ(*,*) iCOLcumQ
C
      WRITE(*,*)
      WRITE(*,*) ' Specify row for pump intake '
      READ(*,*) iROWpump
C
C-----OPEN THE CELL-BY-CELL BUDGET FILE
      WRITE(*,*)
10    WRITE(*,*) ' Enter the name of the file with BINARY info'
      READ(*,'(A)') NAME
      if( NAME(1:1).eq.' ' )  NAME='Output_W4-54-1200.cbc'
      OPEN(UNIT=INBUD,FILE=NAME,STATUS='OLD',FORM=FORM,ACCESS=ACCESS,
     1               ERR=10)
c
c   Add optional routine for interpolating Qsim during a given TimeStep
      nMEAS = 0
      WRITE(*,*)
      WRITE(*,*) ' Specify name of measured Q file:' 
      READ(*,'(a)') TxT
      if( TxT(1:1).eq.' ' ) txt='Pcomp_W4-54-1200.Qmeasured.txt'
      if( len(TxT).gt.2 ) then
        OPEN(io,FILE=txt,STATUS='OLD', ERR=21)
        WRITE(*,*)
        WRITE(*,*) ' Specify file name for simulated Q:'
        READ(*,'(a)') NAME
       if( NAME(1:1).eq.' ' ) NAME='Q.txt'
        OPEN(io+1,FILE=NAME)
c        
        WRITE(*,*)
        WRITE(*,*) ' Enter MF2K DIS file name:'
        READ(*,'(a)') TxT
      if( Txt(1:1).eq.' ' ) txt='INPUT_W4-54-1200.DIS.txt'
        OPEN(io+2,FILE=txt,STATUS='OLD', ERR=21)
        read(io+2,*) nz, ny, nx
        read(io+2,*)
C------Read the DELR and DELC arrays.
        CALL U1DREL(Qacc,txt,nx,io+2,io+1)
        CALL U1DREL(Qacc,txt,Ny,io+2,io+1)
        close(io+2)
        close(io+1)
        OPEN(io+1,FILE=NAME)
        WRITE(*,*)
        WRITE(*,*) ' Specify depth to top of model '
        READ(*,*) DepthDY(1)
        do i = 1, ny
          DepthDY(i+1) = DepthDY(i) + Qacc(i)
        enddo
C------Specify maximum K  to be included in T calc.  
        WRITE(*,*)'Specify maximum K so null cells are not added to T' 
        READ(*,'(a)') TxT
        if( TxT(1:1).eq.' ' ) txt='OUTPUT_Hcond.txt'
        call qread(rN,1,TxT,ierr)
        if( ierr.eq.0 ) then
          HydKmax = rn(1)
c        
C------Read HydK array and compute Transmissivity
          WRITE(*,*) ' Name of K array WithOUT  NX, NY header:' 
          READ(*,'(a)') TxT
          if( TxT(1:1).eq.' ' ) txt='OUTPUT_Hcond.txt'
        else  
          HydKmax = 1.0E12
        endif  
        OPEN(io+2,FILE=txt,STATUS='OLD', ERR=22)
c        read(io+2,*) nx, ny
        read(io+2,*)(buff(i), i=1,nx*ny)
        close(io+2)
c
        TRANS = 0.0
        do i= 1,ny  
          if(buff(i*nx).lt.HydKmax) Trans = Trans + Qacc(i) * buff(i*nx)
        enddo        
c        
        WRITE(*,*) ' Name of TRANSMISSIVITY output file:' 
        READ(*,'(a)') TxT
        if( TxT(1:1).eq.' ' ) txt='OUTPUT_TRANSMISSIVITY.txt'
        OPEN(io+2,FILE=txt)
        write(io+2,'(G20.12)')Trans
        close(io+2)

C------Read Measured depths 
22      do while (nMEAS < MaxHYD1 )
          read(io,'(a)',end=19) TxT
          call caps(TxT,80)
          call qread(rN,1,TxT,ierr)
          if( ierr.lt.1 ) then
            if( index(TxT,'MULTIPLY').gt. 0 ) then
              Qmult = rN(1)
            elseif( index(TxT,'TIME').gt. 0 ) then
              iTS = rN(1)+0.5
            else
              nMeas = nMeas+1
              DepthMEAS(nMEAS) = rN(1)
            endif
          endif
        enddo
      endif      
19    close(io)
C
C-----READ GRID SIZE FROM BUDGET FILE AND REWIND
 21   Kheader = 0
      READ(INBUD,END=2000) KSTP,KPER,TEXT,NCOL,NROW,NLAY
      NZ = Nlay
      if(   ncol.lt.0 .or. ncol.gt.9999 .or. 
     +      nrow.lt.0 .or. nrow.gt.9999 .or.
     +      nlay.lt.-999 .or. nlay.gt.999 ) then
        REWIND(UNIT=INBUD)
        READ(INBUD,END=2000) KSTP,KPER,PERTIM,TOTIM,TEXT,NCOL,NROW,NLAY
        Kheader = 1
      endif  
      IF(NLAY.LT.0) NLAY=-NLAY
      REWIND(UNIT=INBUD)
      WRITE(*,*)
      WRITE(*,14) NLAY,NROW,NCOL
14    FORMAT(1X,I3,' layers',I10,' rows',I10,' columns')
C
C-----CHECK TO SEE IF NODIM IS LARGE ENOUGH
      NRC=NROW*NCOL
      NODES=NRC*NLAY
      IF(NODES.GT.NODDIM) THEN
         WRITE(*,*) ' PROGRAM ARRAYS ARE DIMENSIONED TOO SMALL'
         WRITE(*,*) ' PARAMETER NODDIM IS CURRENTLY',NODDIM
         WRITE(*,*) ' CHANGE NODDIM TO BE',NODES,' OR GREATER'
         STOP
      END IF
c  Scanning for True NZ if Kheader = 1
      if( kheader.eq.1 ) then
        j = 0
        do while( j.lt.999) 
          j = j + 1
          READ(INBUD)KSTP,KPER,PERTIM,TOTIM,TEXT,NCOL,NROW,NLAY
          if( j.gt.1 .and. TOTIM.gt.PERTIM ) then
            NZ = j-1
            j = 1000
            REWIND(UNIT=INBUD)
          else
            READ(INBUD) (BUFF(I),I=1,NODES)
          endif
        enddo
      endif
c          
      WRITE(*,*)    
C
      kOUNT = 0
      ICALC=0
C-----READ BUDGET DATA AND ACCUMULATE AS LONG AS TIME REMAINS CONSTANT.
C-----WHEN TIME CHANGES, PRINT THE BUDGET, REINITIALIZE, AND START OVER
      do while( iout.gt.0)
        if( kheader.eq.0 ) then 
          READ(INBUD,END=1000) KSTP,KPER,TEXT,NC,NR,NL
        else  
          READ(INBUD,END=1000) KSTP,KPER,PERTIM,TOTIM,TEXT,NC,NR,NL
        endif
      ITYPE=0
      IF(NL.LT.0) THEN
         READ(INBUD) ITYPE,DELT,PERTIM,TOTIM
         write(iout,'(i5,3G15.7)') ITYPE,DELT,PERTIM,TOTIM
         NVAL=1
         IF(ITYPE.EQ.5) THEN
            READ(INBUD) NVAL
            IF(NVAL.GT.1) THEN
               DO 101 N=2,NVAL
               READ(INBUD) CTMP
101            CONTINUE
            END IF
         END IF
         IF(ITYPE.EQ. 2 .OR. ITYPE.EQ.5) READ(INBUD) NLIST
      END IF
C
C-----READ THE BUDGET TERM DATA UNDER THE FOLLOWING CONDITIONS:
      IF(ITYPE.EQ.0 .OR. ITYPE.EQ.1) THEN
C  FULL 3-D ARRAY
         koff = mod(kOUNT-1,NZ)*Nrow*ncol
         READ(INBUD) (BUFF(I+koff),I=1,NODES)
         if( TEXT .eq. 'FLOW RIGHT FACE ' )then
           kOUNT = kOUNT + 1
           QaccLAST = 0.000
           k = nrow
           do i = (nrow-1)*ncol+iCOLcumQ, iCOLcumQ,-ncol
             Qacc((kount-1)*nrow+k) = BUFF(I+koff) + QaccLAST
             QaccLAST = Qacc((kount-1)*nrow+k)
             k = k-1
           enddo
           if( iROWpump.gt.0 ) then 
             do i = 1, iROWpump
               Qacc((kount-1)*nrow+i)= QaccLAST - Qacc((kount-1)*nrow+i)
             enddo
           endif
         endif  
      ELSE IF(ITYPE.EQ.3) THEN
C  1-LAYER ARRAY WITH LAYER INDICATOR ARRAY
         DO 260 I=1,NODES
         BUFF(I)=ZERO
260      CONTINUE
         READ(INBUD) (IBUFF(I),I=1,NRC)
         READ(INBUD) (BUFF(I),I=1,NRC)
         DO 270 I=1,NRC
         IF(IBUFF(I).NE.1) THEN
            LAYMOV=(IBUFF(I)-1)*NRC
            BUFF(LAYMOV+I)=BUFF(I)
            BUFF(I)=ZERO
         END IF
270      CONTINUE
      ELSE IF(ITYPE.EQ.4) THEN
C  1-LAYER ARRAY THAT DEFINES LAYER 1
         READ(INBUD) (BUFF(I),I=1,NRC)
         IF(NODES.GT.NRC) THEN
            DO 280 I=NRC+1,NODES
            BUFF(I)=ZERO
280         CONTINUE
         END IF
      ELSE IF(ICALC.EQ.0 .AND. NLIST.GT.0) THEN
C  LIST -- READ ONLY IF THE VALUES NEED TO BE SKIPPED
         DO 300 N=1,NLIST
         READ(INBUD) LOC,(VAL(I),I=1,NVAL)
300      CONTINUE
      END IF
       
      enddo   !! BOTTOM of DoWhile loop
c-------------------------------------------------- 
c
1000  continue 
C  PRINT BUDGET BECAUSE END OF FILE WAS REACHED 
c  Write CBC to ASCII
      do i = 1, nrow
        ne = (kount-1)*nrow + i
        write(iout,'(500(a1,G16.8))')(tab,Qacc(j),j=i,ne,nrow)
      enddo
c
c  Interpolate and kick-out Depth dependent info      
      do i = 1, nMEAS
        k = MATCH(DepthMEAS(i), DepthDY, nROW)
        ne = (iTS-1)*nrow + k
        Qsim = Yinterp(DepthMEAS(i),DepthDY(k),DepthDY(k+1), 
     +                 Qacc(ne),Qacc(ne+1))
        Qsim = Qsim * Qmult
        write(io+1,'(2G16.8)')DepthMEAS(i), Qsim
      enddo
c      
      STOP
C
C-----EMPTY BUDGET FILE
2000  WRITE(*,*) 'CELL-BY-CELL FLOW TERM FILE WAS EMPTY'
      STOP
C
      END
c
c-----------------------------------------------------------------------
c
      subroutine qread(r,ni,ain,ierr)
      PARAMETER (mrnv=999)
      dimension r(mrnv)                                                        
      character*1   tab                                                      
      character*16  form                                                      
      character*2048 atxt, ain  
      maxalp = 2048                                                
      tab = char(9)                         !!     sets  tab delimiter
c                                                                             
c   r(ni+1) records the number of non-numeric entries that were attempted to be read as a number                                                                              
c   r(ni+2) records the last column that was read from the card
c                                                                             
      r(ni+1) = -1.0000
      atxt = ain                                                              
      do i = 1, maxalp
        if( atxt(i:i).eq.tab ) atxt(i:i) = ' '
        if( atxt(i:i).eq.',' ) atxt(i:i) = ' '
        if( atxt(i:i).eq.':' ) atxt(i:i) = ' '
        if( atxt(i:i).eq.'=' ) atxt(i:i) = ' '
      enddo
      n = 1                                                                   
      i = 0                                                                   
   11 r(ni+1) = r(ni+1) + 1
   10 i = i+1                                                                 
      if( i.ge.maxalp ) goto 15                                                   
      if( atxt(i:i).eq.' ' ) then                        
        atxt(i:i) = '?'                                                       
        goto 10                                                               
      endif                                                                   
c                                                                             
      ki = index(atxt,' ')-1                                                  
      nd = ki - i + 1                                                         
      form ='(F??.0)              '                                         
      write(form(3:4),'(i2.2)') nd
      READ (atxt(I:KI),FORM,ERR=13,IOSTAT=ISTAT) R(N)
   13 CONTINUE
      i = ki
      IF (ISTAT.GT.0) GOTO 11  ! PART OF BUG FIX -- ERB
      n = n+1
      if( n.le.ni .and. i.lt.maxalp) goto 10
c                                                                             
  15  n  = n-1                                                                
      ierr = ni - n   
	r(ni+2) = i                                                        
      return                                                                  
      end                                                                     
c___________________________________________________________
c
      subroutine caps(a1,n)
      character*1 lc(26), uc(26)
      character*2048  a1
      data lc /'a','b','c','d','e','f','g','h','i','j','k','l','m','n',
     .         'o','p','q','r','s','t','u','v','w','x','y','z'/
      data uc /'A','B','C','D','E','F','G','H','I','J','K','L','M','N',
     .         'O','P','Q','R','S','T','U','V','W','X','Y','Z'/
	do i=1,n
        j = 0
        do while( j.lt.26 )
          j = j + 1
          if( a1(i:i).eq.lc(j) ) then 
            a1(i:i) = uc(j)
	      j = 26
          endif
        enddo
      enddo
c
      return
      end
c___________________________________________________________
c
      integer function MATCH(dTest, dARR, nARR)
      PARAMETER (mrnv=999)
      dimension dARR(mrnv) 
c
      match = 0
      if( dTest.gt.dARR(1) ) then
        i = 0
        do while( i .le. nARR )
          i = i+1
          if( dArr(i).gt.dTest )then
            MATCH = i-1
            i = nARR+1
          endif
        enddo
      endif 
c
      return
      end
c___________________________________________________________
c
      function Yinterp(x,X1,X2,Y1,Y2)
c
      Yinterp = (y1+Y2)*0.5
      if((x2-x1)**2.gt.1.0E-20 ) then 
        Yinterp = (Y2-Y1)/(x2-x1)
        Yinterp = (x-x1) * Yinterp + Y1
      endif
c
      return
      end
     